# Trace
Modern Crypto Portfolio & Market Explorer. Built with [Flutter](https://github.com/flutter/flutter).  
Open Source. Lightweight. Clean. Straightforward. Fast. Powerful.

Download for Android on [Google Play](https://play.google.com/store/apps/details?id=com.trentpiercy.trace). Join [Android Beta](https://play.google.com/apps/testing/com.trentpiercy.trace)!  
Building for iOS works just fine, but I'm not giving Apple $99 to put this on the AppStore right now.

<a href='https://play.google.com/store/apps/details?id=com.trentpiercy.trace&pcampaignid=MKT-Other-global-all-co-prtnr-py-PartBadge-Mar2515-1'><img alt='Get it on Google Play' src='https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png' height=75/></a>

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/gifs/portfolio.gif" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/gifs/markets.gif" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/gifs/themes.gif" width="32%">

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/gifs/coin_stats.gif" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/gifs/timeline_breakdown.gif" width="49%">

### Features
💰 Portfolio Overview  
🌎 Aggregate Market Explorer  
📊 Detailed Aggregate/Exchange Specific Market Data for every Coin  
📈 Portfolio Timeline  
📅 Transaction History  
⭕️ Portfolio Breakdown  
🌓 Automatic, Light, Dark & Dark OLED Theme Options  
⚡ 7.3MB - Fast & Lightweight

**[📹 Full Video](https://youtu.be/Di7MxXioESQ)**

## Screenshots
💰 **Portfolio**
- Home screen displaying portfolio value, 7D Change, 24h Change, and value and amount of each coin
- Sort coins by name, holdings, and 24h change percent
- Add transactions using bottom right button

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_01.png" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_04.png" width="49%">

🌎 **Aggregate Markets**
- Swipe to second tab displaying aggregate market stats of every cryptocurrency
- Search by any coin's symbol or name
- Sort coins by name, market cap, 24h trade volume and 24h change percent

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_02.png" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_03.png" width="49%">

📈 **Portfolio Timeline**
- Navigate to timeline through drawer menu or swipe from breakdown
- Tap clock to control timeline period from 1 day to all
- Includes portfolio value high/low, change percent and change amount over period
- Scroll down to view all transaction history

⭕️ **Portfolio Breakdown**
- Navigate to breakdown through drawer menu or swipe from timeline
- Pie chart breakdown of portfolio
- Displays total portfolio value, net percent, net amount and total cost
- Lists each coin as percent of total portfolio

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_07.png" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_09.png" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_10.png" width="32%">

📊 **Detailed Market Data**
- Tap on any coin to view detailed market data
- Tap clock to control candlestick data period from 1 hour to 1 year
- Includes price high/low and change percent over period
- Tap arrows to control candlestick width from 1 minute to 14 days
- Swipe to view list of all exchanges for specific coin
- Includes 24h trade volume along with price and 24h change
- Sort by exchange name, 24h volume, price and 24h change
- Tap on any exchange to get even more detailed data

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_11.png" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_12.png" width="32%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_17.png" width="32%">

☀️ **Light Theme**

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_13.png" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_16.png" width="49%">

🌙 **OLED Dark Theme**

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_14.png" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_15.png" width="49%">

⚙️ **Settings**
- Navigate to settings through drawer menu
- Theme Toggles: automatic, light, dark and dark OLED
- Abbreviate Numbers switch
- Export/Import portfolio JSON to/from text
- Clear Portfolio

<img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_05.png" width="49%"> <img src="https://raw.githubusercontent.com/trentpiercy/trace/master/screenshots/flutter_06.png" width="49%">

## Building Source
- Set your working directory to the root of your git clone
- Make sure your Android SDK and Flutter are up to date (`flutter upgrade`)
- Execute `flutter run`
